/*
    AQTRONIX C++ Library
    Copyright 2004-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// ClientSocket.h: interface for the CClientSocket class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CLIENTSOCKET_H__3556EFCD_97F2_4E89_8F1C_7437060F5663__INCLUDED_)
#define AFX_CLIENTSOCKET_H__3556EFCD_97F2_4E89_8F1C_7437060F5663__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxsock.h>

class CClientSocket : public CSocket
{
public:

	BOOL CreateSync(UINT nSocketPort = 0,int nSocketType = SOCK_STREAM,LPCTSTR lpszSocketAddress = NULL);
	BOOL CreateAsync(UINT nSocketPort = 0,int nSocketType = SOCK_STREAM,long lEvent = FD_READ|FD_WRITE|FD_OOB|FD_ACCEPT|FD_CONNECT|FD_CLOSE);

	BOOL Connect(LPCTSTR Host, unsigned int Port);
	BOOL KillTimeOut();
	BOOL SetTimeOut(UINT uTimeOut);
	void OnReceive(int nErrorCode);

	virtual CString Receive();
	virtual bool Send(const char* Packet);

	CClientSocket();
	virtual ~CClientSocket();

protected:
	void DestroyArchives();
	void CreateArchives(bool Sending = true, bool Receiving = true);
	BOOL OnMessagePending();
	UINT_PTR TimerID;
	CArchive* ArchiveIn;
	CArchive* ArchiveOut;
	CSocketFile* SocketFile;
};

#endif // !defined(AFX_CLIENTSOCKET_H__3556EFCD_97F2_4E89_8F1C_7437060F5663__INCLUDED_)
