/*
    AQTRONIX C++ Library
    Copyright 2003-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// Settings.h: interface for the CSettings class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SETTINGS_H__270445F3_48E4_49D3_8EAF_CAB52E330BF9__INCLUDED_)
#define AFX_SETTINGS_H__270445F3_48E4_49D3_8EAF_CAB52E330BF9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "FileName.h"
#include "XML.h"
#include "StringHelper.h"
#include <afxmt.h>		// for synchronization objects

#define CSETTINGS_MAX_XML_FILE 1024000

#define READ_INI_BOOL(location,var) \
		;##location.##var = GetPrivateProfileInt(#location,#var,##location.##var,fn)>0;

#define READ_INI_INT(location,var) \
		;##location.##var = GetPrivateProfileInt(#location,#var,##location.##var,fn);

//#define READ_INI_LONG(location,var) \
//		GetPrivateProfileString(#location,#var,CStringHelper::Safe_LongToAscii(##location.##var),buf,sz,fn) \
//		;##location.##var = atol(buf); \

#define READ_INI_STRING(location,var) \
		GetPrivateProfileString(#location,#var,##location.##var,buf,sz,fn) \
		;##location.##var = buf; CleanupString(##location.##var); \

//#define READ_INI_STRING(location,var) \
//		{ CString strini(##location.##var); \
//		GetPrivateProfileString(#location,#var,"",buf,sz,fn) \
//		;##location.##var = buf; CleanupString(##location.##var); \
//		if(##location.##var==""){##location.##var=strini;}}

#define READ_INI_CSTRINGLIST(location,var,cleanup) \
		l = GetPrivateProfileSection(#location "." #var,buf,sz,fn);\
		Split(buf,l,##location.##var)\
		;##cleanup(##location.##var);

#define READ_INI_LIST(location,var,cleanup)\
		;##location.##var.Enabled = GetPrivateProfileInt(#location,#var,##location.##var.Enabled,fn)>0;\
		l = GetPrivateProfileSection(#location "." #var,buf,sz,fn);\
		Split(buf,l,##location.##var.List)\
		;##cleanup(##location.##var.List);

#define READ_INI_MAP(location,var,cleanup)\
		;##location.##var.Enabled = GetPrivateProfileInt(#location,#var,##location.##var.Enabled,fn)>0;\
		l = GetPrivateProfileSection(#location "." #var,buf,sz,fn);\
		if(l>0){\
			CStringList list;\
			Split(buf,l,list)\
			;##cleanup(list)\
			;##location.##var.Map.RemoveAll();\
			POSITION pos = list.GetHeadPosition();\
			CString val; int poseq; CString tmp;\
			while (pos!=NULL){\
				CString& str = list.GetNext(pos);\
				poseq = str.Find('=');\
				if(poseq!=-1){\
					if(str.Mid(poseq+1) != ""){\
						tmp = str.Mid(0,poseq)\
						;##location.##var.Map.SetAt(tmp,str.Mid(poseq+1));\
					}\
				}\
			}\
		}

#define READ_INI_CACHE(location,var) \
		;##location.##var.Enabled = GetPrivateProfileInt(#location,#var ".Enabled",##location.##var.Enabled,fn)>0\
		;##location.##var.MaxCount = GetPrivateProfileInt(#location,#var ".MaxCount",##location.##var.MaxCount,fn)\
		;##location.##var.MaxTime = GetPrivateProfileInt(#location,#var ".MaxTime",##location.##var.MaxTime,fn);

#define WRITE_INI_BOOL(location,var) \
	WritePrivateProfileString(#location,#var,##location.##var?"1":"0",fn);
#define WRITE_INI_INT(location,var) \
	WritePrivateProfileString(#location,#var,CStringHelper::Safe_IntToAscii(##location.##var),fn);
//#define WRITE_INI_LONG(location,var) \
//	WritePrivateProfileString(#location,#var,CStringHelper::Safe_LongToAscii(##location.##var),fn);
#define WRITE_INI_STRING(location,var) \
	WritePrivateProfileString(#location,#var,##location.##var,fn);
#define WRITE_INI_CSTRINGLIST(location,var) \
	WritePrivateProfileSection(#location "." #var,ConvertListToString(##location.##var),fn);
#define WRITE_INI_LIST(location,var) \
	WritePrivateProfileString(#location,#var,##location.##var.Enabled?"1":"0",fn);\
	WritePrivateProfileSection(#location "." #var,ConvertListToString(##location.##var.List),fn);
#define WRITE_INI_MAP(location,var) \
	WritePrivateProfileString(#location,#var,##location.##var.Enabled?"1":"0",fn);\
	WritePrivateProfileSection(#location "." #var,ConvertMapToString(##location.##var.Map),fn);
#define WRITE_INI_CACHE(location,var) \
	WritePrivateProfileString(#location,#var ".Enabled",##location.##var.Enabled?"1":"0",fn);\
	WritePrivateProfileString(#location,#var ".MaxTime",CStringHelper::Safe_IntToAscii(##location.##var.MaxTime),fn);\
	WritePrivateProfileString(#location,#var ".MaxCount",CStringHelper::Safe_IntToAscii(##location.##var.MaxCount),fn);


#define PARSE_XML_BOOL(location,var,xmlkey) \
	if(name.CompareNoCase(xmlkey)==0){ if(val=="1"){ ##location.##var=true; }else{ if(val=="0"){ ##location.##var=false; }} }
#define PARSE_XML_INT(location,var,xmlkey,cast) \
	if(name.CompareNoCase(xmlkey)==0){ ##location.##var = ##cast Safe_AsciiToInt(XMLDecode(val),##location.##var,##location.##var); }
//#define PARSE_XML_LONG(location,var,xmlkey,cast) \
//	if(name.CompareNoCase(xmlkey)==0){ ##location.##var = ##cast Safe_AsciiToLong(XMLDecode(val),##location.##var,##location.##var); }
#define PARSE_XML_STRING(location,var,xmlkey) \
	if(name.CompareNoCase(xmlkey)==0){ ##location.##var = XMLDecode(val); }
#define PARSE_XML_CSTRINGLIST(location,var,xmlkey) \
	if(name.CompareNoCase(xmlkey)==0){ ConvertXMLToList(val,##location.##var); }
#define PARSE_XML_LIST(location,var,xmlkey) \
	if(name.CompareNoCase("Use_" xmlkey)==0){ ##location.##var.Enabled = val=="1"?true:false; } \
	else if(name.CompareNoCase(xmlkey)==0){ ConvertXMLToList(val,##location.##var.List); }
#define PARSE_XML_MAP(location,var,xmlkey) \
	if(name.CompareNoCase("Use_" xmlkey)==0){ ##location.##var.Enabled = val=="1"?true:false; } \
	else if(name.CompareNoCase(xmlkey)==0){ ConvertXMLToMap(val,##location.##var.Map); }

#define PARSE_XML_CACHE(location,var,xmlkey) \
	if(name.CompareNoCase("Use_" xmlkey)==0){ ##location.##var.Enabled = val=="1"?true:false; } \
	else if(name.CompareNoCase(xmlkey "_Max_Count")==0){ ##location.##var.MaxCount = CStringHelper::Safe_AsciiToInt(XMLDecode(val)); } \
	else if(name.CompareNoCase(xmlkey "_Max_Time")==0){ ##location.##var.MaxTime = CStringHelper::Safe_AsciiToInt(XMLDecode(val)); }


#define WRITE_XML_BOOL(location,var,xmlkey,explanation) \
	xml += ConvertStringToXML(xmlkey,"Option",##location.##var?"1":"0",d.##location.##var?"1":"0",explanation);
#define WRITE_XML_INT(location,var,xmlkey,explanation) \
	xml += ConvertStringToXML(xmlkey,"Text",CStringHelper::Safe_IntToAscii(##location.##var),CStringHelper::Safe_IntToAscii(d.##location.##var),explanation);
//#define WRITE_XML_LONG(location,var,xmlkey,explanation) \
//	xml += ConvertStringToXML(xmlkey,"Text",CStringHelper::Safe_LongToAscii(##location.##var),CStringHelper::Safe_LongToAscii(d.##location.##var),explanation);
#define WRITE_XML_STRING(location,var,xmlkey,explanation) \
	xml += ConvertStringToXML(xmlkey,"Text",##location.##var,d.##location.##var,explanation);
#define WRITE_XML_LIST(location,var,xmlkey,explanation1, explanation2) \
	xml += ConvertStringToXML("Use_" xmlkey,"Option",##location.##var.Enabled?"1":"0",d.##location.##var.Enabled?"1":"0",explanation1); \
	xml += ConvertListToXML(xmlkey,##location.##var.List,explanation2);
#define WRITE_XML_MAP(location,var,xmlkey,explanation1, explanation2) \
	xml += ConvertStringToXML("Use_" xmlkey,"Option",##location.##var.Enabled?"1":"0",d.##location.##var.Enabled?"1":"0",explanation1); \
	xml += ConvertMapToXML(xmlkey,##location.##var.Map,explanation2);

#define WRITE_XML_CSTRINGLIST(location,var,xmlkey,explanation) \
	xml += ConvertListToXML(xmlkey,##location.##var,explanation);
#define WRITE_XML_CACHE(location,var,xmlkey,explGeneral,explCount,explTime) \
	xml += ConvertStringToXML("Use_" xmlkey,"Option",##location.##var.Enabled?"1":"0",d.##location.##var.Enabled?"1":"0",explGeneral); \
	xml += ConvertStringToXML(xmlkey "_Max_Count","Text",CStringHelper::Safe_IntToAscii(##location.##var.MaxCount),CStringHelper::Safe_IntToAscii(d.##location.##var.MaxCount),explCount); \
	xml += ConvertStringToXML(xmlkey "_Max_Time","Text",CStringHelper::Safe_IntToAscii(##location.##var.MaxTime),CStringHelper::Safe_IntToAscii(d.##location.##var.MaxTime),explTime);
	

class CSettings: public CStringHelper, public CXML, public CObject
{

public:

	//general classes
	class _StringList{
	public:
		bool Enabled;
		CStringList List;
	};

	class _StringMap{
	public:
		bool Enabled;
		CMapStringToString Map;
	};

	class _StringCache{
	public:
		bool Enabled;
		unsigned int MaxTime;
		unsigned int MaxCount;
	};

	CString SetReadSettingsFileName(LPCTSTR fn);
	CString GetLoadedSettingsFileName();
	CString GetReadSettingsFileName();
	static bool WriteXMLEntityToFile(LPCTSTR fn, LPCTSTR XML);
	static bool WriteXMLEntityToFile(LPCTSTR fn,LPCTSTR EntityName,LPCTSTR XML);
	virtual bool CheckConstraints();
	virtual bool ProcessFile(LPCTSTR fn);
	virtual CString ToXML() = 0;
	virtual bool WriteToFile(LPCTSTR fn);
	virtual bool WriteToRegistry();
	virtual bool WriteToActiveDirectory();
	virtual bool UpdateFromFile();
	virtual bool ReadFromActiveDirectory();
	virtual bool ReadFromRegistry();
	virtual bool ParseXML(CString& key, CString& val) = 0;
	virtual bool ReadFromFile(LPCTSTR fn);
	virtual void LoadDefaults() = 0;
	virtual bool Update();

	CSettings();
	virtual ~CSettings();

	CCriticalSection crit;

protected:
	virtual bool WriteToFileINI(LPCTSTR fn) = 0;
	virtual bool WriteToFileXML(LPCTSTR fn) = 0;
	virtual bool ReadFromFileINI(LPCTSTR fn) = 0;
	virtual bool ReadFromFileXML(LPCTSTR fn);

	static void ConvertXMLToMap(CString& val, CMapStringToString& map);
	static void ConvertXMLToList(CString& val, CStringList& list);
	static CString XMLKeyParameter(CString key, CString par);

	static CString ConvertStringToXML(LPCTSTR tag, LPCTSTR app, LPCTSTR value, LPCTSTR defaultvalue, LPCTSTR explanation = "");
	static CString ConvertMapToXML(LPCTSTR tag,CMapStringToString& map, LPCTSTR explanation = "");
	static CString ConvertListToXML(LPCTSTR tag, CStringList& List, LPCTSTR explanation = "");
	static CString ConvertMapToString(const CMapStringToString& map);
	static CString ConvertListToString(const CStringList& list);

	static void CleanupStringUCase(CString &str);
	static void CleanupListUCase(CStringList &list);
	static void CleanupListLCase(CStringList& list);
	static void CleanupList(CStringList& list);
	static void CleanupString(CString& str);
	static void CleanupStringLCase(CString& str);

	class _UpdateStamp{
	public:
		CTime Time;
		CTime FileName_Timestamp;
		CString FileName;
	} UpdateStamp;
	CString fn_loaded; //reflected settings file name "Loaded.xml"
};

#endif // !defined(AFX_SETTINGS_H__270445F3_48E4_49D3_8EAF_CAB52E330BF9__INCLUDED_)
