#include "stdafx.h"
#include "LogAnalysisSettings.h"

CLogAnalysisSettings::CLogAnalysisSettings(void)
{
	LoadDefaults();
}

CLogAnalysisSettings::~CLogAnalysisSettings(void)
{
}

void CLogAnalysisSettings::LoadDefaults()
{
	General.Separator = "";
	General.SortedColumn = -1;
	Filter.Include.RemoveAll();
	Filter.Exclude.RemoveAll();
}

bool CLogAnalysisSettings::WriteToFileINI(LPCTSTR fn)
{
	//Response handling
	WRITE_INI_STRING(General,Separator)
	WRITE_INI_INT(General,SortedColumn)
	WRITE_INI_CSTRINGLIST(Filter,Include)
	WRITE_INI_CSTRINGLIST(Filter,Exclude)

	return true;
}

bool CLogAnalysisSettings::ReadFromFileINI(LPCTSTR fn)
{
	const int sz = MAX_INI_FILE_SIZE;
	char buf[sz];
	DWORD l(0);

	READ_INI_STRING(General,Separator)
	READ_INI_INT(General,SortedColumn)
	READ_INI_CSTRINGLIST(Filter,Include)
	READ_INI_CSTRINGLIST(Filter,Exclude)

	return true;
}

bool CLogAnalysisSettings::ParseXML(CString &key, CString &val)
{
	//if not a valid key
	if (key=="")
		return false;

	CString name = XMLDecode(XMLKeyParameter(key,"name"));
	
	//Response Handling
		 PARSE_XML_STRING(General,Separator,"Separator")
	else PARSE_XML_INT(General,SortedColumn,"SortedColumn")
	else PARSE_XML_CSTRINGLIST(Filter,Include,"Filter_Include")
	else PARSE_XML_CSTRINGLIST(Filter,Exclude,"Filter_Exclude")

	else{
		return false;
	}
	return true;
}

CString CLogAnalysisSettings::ToXML()
{
	CString xml("");
	CLogAnalysisSettings d;

	WRITE_XML_STRING(General,Separator,"Separator","The separator for the fields")
	WRITE_XML_INT(General,SortedColumn,"SortedColumn","The column index to be sorted ascending")
	WRITE_XML_CSTRINGLIST(Filter,Include,"Filter_Include","Only see entries with these strings")
	WRITE_XML_CSTRINGLIST(Filter,Exclude,"Filter_Exclude","Ignore entries with these strings")

	return xml;
}

bool CLogAnalysisSettings::WriteToFileXML(LPCTSTR fn)
{
	return WriteXMLEntityToFile(fn,"LogAnalysis",ToXML());
}

bool CLogAnalysisSettings::IsAllowedByFilters(CString& Line)
{
	if(Filter.Include.GetCount()>0){
		CStringList Matches;
		if(Filter.Include.GetCount()!=CStringHelper::CountKeywords(Line,Filter.Include,Matches)){
			return false;
		}
	}
	if(Filter.Exclude.GetCount()>0){
		if(CStringHelper::IsListItemInStringCompareNoCase(Line,Filter.Exclude)){
			return false;
		}
	}
	return true;
}

