#pragma once
#include "afxwin.h"

#include "resource.h"       // main symbols
#include "LogViewDetails.h"
#include "LogAnalysisSettings.h"

class CLogViewList : public CView
{
protected:
	DECLARE_DYNCREATE(CLogViewList)
public:
	//settings
	CLogAnalysisSettings Settings;

	//listcontrol
	CListCtrl loglist;
	CString HeaderDate;
	CString HeaderName;
	int ColumnCount;
	CLogViewDetails* pDetails;
protected:
	//file
	CString fn;
	ULONGLONG CurrentPosition;
	bool AbortBinding;
	//columns
	CStringArray FieldList;
	//filters
	void BindDetailToList();
	int filtered_count;
public:
	//file
	bool OpenLog(LPCTSTR fn);
	bool ReadLog(LPCTSTR fn, LONGLONG Start=0);
	bool ReadLogAppend();
	void RefreshLog();
	void CloseLog();

	//columns
	void SortColumn(int ColumnIndex, bool Ascending);
	void SetColumns(CStringList& Fields, bool UseFieldNameAsColumnHeading);
	void SetColumns(CString& Fields, bool UseFieldNameAsColumnHeading);
	void SetHeaders(CString& Header);
	int CalculateColumnWidth(CString& Fld, int MinimumLength, int MaximumLength);
	CString DetectSeparator(CString& Line);

	//rows
	bool AddLine(CString& Line);
	void AddLines(CStringList& lines);
	void Clear();
	CString GetCurrentEntry();
	int EntryCount() const;
	int FilteredCount() const;
	CFont font;

	//filters
	virtual void AddFilter(CString& Text, int FilterType);
	virtual void ClearFilters();

public:
	CLogViewList(void);
	~CLogViewList(void);

	// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
public:
	DECLARE_MESSAGE_MAP()
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	void OnItemclickListSort(NMHDR* pNMHDR, LRESULT* pResult);
	static int CALLBACK SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
};
